Loading...
Searching...
No Matches
Erroneous Headers
Headers

The erroneous headers are stored in msg_error_t structure. More...

## Macros

#define | MSG_ERROR_INIT()
| Initializer for structure msg_error_t.

## Typedefs

typedef struct msg_error_s | msg_error_t
| Type for erroneous headers.

## Enumerations

enum | { msg_error_hash }

## Functions

msg_error_t * | msg_error_init (msg_error_t x[1])
| Initialize a structure msg_error_t.
int | msg_is_error (msg_header_t const *header)
| Test if header object is instance of msg_error_t.
msg_error_t * | msg_error_dup (su_home_t *home, msg_error_t const *header))
| Duplicate (deep copy) `msg_error_t`.
msg_error_t * | msg_error_copy (su_home_t *home, msg_error_t const *header))
| Copy a msg_error_t header structure.
msg_error_t * | msg_error_make (su_home_t *home, char const *s)
| Make a header structure msg_error_t.
msg_error_t * | msg_error_format (su_home_t *home, char const *fmt,...)))
| Make a erroneous headers from formatting result.

## Variables

msg_parse_f | msg_error_d
| Parse a erroneous headers.
msg_print_f | msg_error_e
| Print a erroneous headers.
msg_hclass_t | msg_error_class []
| Header class for erroneous headers.

## Detailed Description

The erroneous headers are stored in msg_error_t structure.

Note
  Parser may put other headers (like duplicate Content-Length headers) into the list of erroneous headers. If the list of erroneous headers is processed, the header type must be validated first by calling msg_is_error() (or by other relevant tests).

## Macro Definition Documentation

## MSG_ERROR_INIT

#define MSG_ERROR_INIT | ( |  | ) |

Initializer for structure msg_error_t.

A static msg_error_t structure must be initialized with the MSG_ERROR_INIT() macro. For instance,

msg_error_t msg_error = MSG_ERROR_INIT;
msg_error_t
struct msg_error_s msg_error_t
Type for erroneous headers.
Definition msg_types.h:94
MSG_ERROR_INIT
#define MSG_ERROR_INIT()
Initializer for structure msg_error_t.
Definition msg_protos.h:340

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
msg_error_hash | Hash of erroneous headers.

## Function Documentation

## msg_error_copy()

msg_error_t * msg_error_copy | ( | su_home_t * | home,
|  | msg_error_t const * | header )

inline

Copy a msg_error_t header structure.

The function msg_error_copy() copies a header structure header. If the header structure header contains a reference (`header->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure header.

Parameters

  home | memory home used to allocate new structure
  header | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  error = msg_error_copy(home, msg->msg_error);
  msg_error_copy
  msg_error_t * msg_error_copy(su_home_t *home, msg_error_t const *header))
  Copy a msg_error_t header structure.
  Definition msg_protos.h:471

Returns
  The function msg_error_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## msg_error_dup()

msg_error_t * msg_error_dup | ( | su_home_t * | home,
|  | msg_error_t const * | header )

inline

Duplicate (deep copy) `msg_error_t`.

The function msg_error_dup() duplicates a header structure header. If the header structure header contains a reference (`header->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  header | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  error = msg_error_dup(home, msg->msg_error);
  msg_error_dup
  msg_error_t * msg_error_dup(su_home_t *home, msg_error_t const *header))
  Duplicate (deep copy) msg_error_t.
  Definition msg_protos.h:425

Returns
  The function msg_error_dup() returns a pointer to the newly duplicated msg_error_t header structure, or NULL upon an error.

## msg_error_format()

msg_error_t * msg_error_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a erroneous headers from formatting result.

The function msg_error_format() makes a new erroneous headers object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function is usually implemented as a macro calling msg_header_format().

Returns
  The function msg_error_format() returns a pointer to newly makes header structure, or NULL upon an error.

## msg_error_init()

msg_error_t * msg_error_init | ( | msg_error_t | x[1] | ) |

inline

Initialize a structure msg_error_t.

An msg_error_t structure can be initialized with the msg_error_init() function/macro. For instance,

msg_error_t msg_error;
msg_error_init(&msg_error);
msg_error_init
msg_error_t * msg_error_init(msg_error_t x[1])
Initialize a structure msg_error_t.
Definition msg_protos.h:357

Parameters

  x | pointer to msg_error_t structure

## msg_error_make()

msg_error_t * msg_error_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure msg_error_t.

The function msg_error_make() makes a new msg_error_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function is usually implemented as a macro calling msg_header_make().

Returns
  The function msg_error_make() returns a pointer to newly maked msg_error_t header structure, or NULL upon an error.

## msg_is_error()

int msg_is_error | ( | msg_header_t const * | header | ) |

inline

Test if header object is instance of msg_error_t.

The function msg_is_error() returns true (nonzero) if the header class is an instance of erroneous headers object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function msg_is_error() returns true (nonzero) if the header object is an instance of header error and false (zero) otherwise.

## Variable Documentation

## msg_error_class

msg_hclass_t msg_error_class[]

extern

Header class for erroneous headers.

The header class msg_error_class defines how a erroneous headers header is parsed and printed. It also contains methods used by message parser and other functions to manipulate the msg_error_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.